@ECHO OFF
cd|set /p TOPDIR=
set MVF=mvf.exe
set UBOOTNAME=LOADER
set FWNAMECODE=PROGRAM0
set FWNAMEDATA=DSRAM
set IMG=image
set PROGNAME=%0
set BOARD=hba
set DEV_LIST=
set OPTS=
if "%1"=="" goto DO_FLASH
:loop
if "%1"=="-h" goto help
if "%1"=="-help" goto help
if "%1"=="" goto DO_FLASH
if "%1"=="-e" set OPTS=%OPTS% %1
if "%1"=="-e" goto next
if "%1"=="-a" set OPTS=%OPTS% %1
if "%1"=="-a" goto next
if "%1"=="-y" set OPTS=%OPTS% %1
if "%1"=="-y" goto next
if "%1"=="-b" set OPTS=%OPTS% %1 %2
if "%1"=="-b" goto next
if "%1"=="-x" set OPTS=%OPTS% %1
if "%1"=="-x" goto next
if "%1"=="-w" set OPTS=%OPTS% %1
if "%1"=="-w" goto next
if "%1"=="-v" set OPTS=%OPTS% %1
if "%1"=="-v" goto next
if "%1"=="-r" set OPTS=%OPTS% %1
if "%1"=="-r" goto next

goto fail_command

:next
shift
goto loop

:device_list
shift
set DEV_ID=%1
if "%1"=="" goto fail_end
goto %DEV_ID%_ID

:6122_ID
:6145_ID
:6440_ID
:6480_ID
:8480_ID
:8180_ID
:0000_ID
goto device_list

REM VILI ID
:8120_ID
:8110_ID
REM MAGNI ID
:9011_ID
:9020_ID
:9022_ID
:9110_ID
:9111_ID
:9120_ID
:9122_ID
:9125_ID
:9023_ID
:9123_ID
:914A_ID
:914B_ID
:914C_ID
:914D_ID
:914E_ID
:914F_ID
:90A3_ID
:9190_ID
:9191_ID
:91A0_ID
:91A3_ID
:91A5_ID
:914D_ID
:91A4_ID
:9128_ID
:91A8_ID
:9028_ID
REM for recovery
:91CD_ID
goto DO_FLASH

:evb
REM set UBOOTADDR=0x70000
REM set UBOOTCS=3
ReM set LOKIADDR=0x200000
REM set LOKICS=1
goto DO_FLASH

:hba
set UBOOTADDR=0xFFFF0000
set UBOOTCS=3
set BIOSADDR=0x38000
set LOKIADDRCODE=0x10000
set VILIIMGADDR=0x10000
set LOKIADDRDATA=0x20000
set LOKICS=3
goto DO_FLASH

:DO_FLASH
echo ----------------------------------------------------------------------
echo                           MARVELL FLASH TOOL
echo ----------------------------------------------------------------------
:DO_FL1
cd bin
call mvm.bat %IMG% %OPTS%
if not ERRORLEVEL 1 goto end
echo Flash error, wipeout autoload!!
call mvm.bat %IMG% -a -e -y
goto end

:erase
if "%BOARD%"=="" goto help
echo erase for %BOARD%...
goto erase%BOARD%
goto end

REM Do help screen
:help
echo ----------------------------------------------------------------------
echo                        MARVELL FLASH TOOL HELP
echo ----------------------------------------------------------------------
echo type 'go'         Update Magni Firmware
echo type 'go -y'      Update Magni Firmware with Yes included
REM Have split screen
if "%OPTS%"=="-v" goto detailed
shift
if "%1"=="-v" goto detailed
echo type 'go -h'      Display simple help screen (this screen)
goto end
:detailed
echo type 'go -h -v'   Display detailed help screen (this screen)
echo type 'go -e'      Erase every sector
echo type 'go -a'      Flash only autoload
echo type 'go -b'      Flash only BIOS on MAGNI
echo type 'go -b -e'   Erase only BIOS
echo type 'go -x'      Flash only Firmware on MAGNI
echo type 'go -x -e'   Erase only Firmware on MAGNI
echo type 'go -v'      Show verbose message
echo type 'go -r'      Read back binary file, no flashing
goto end

:fail_end
echo Did not find device! Check connection.
goto end

:fail_command
echo Bad Command.  Please check with help!
goto end

:end
set PROGNAME=
set BOARD=
set NORAID=
set OPTS=
set ERASE=
set LOKICS=
set LOKIADDR=
set UBOOTCS=
set UBOOTADDR=
set MVF=
set FWNAME=
set IMAGE=
cd..
